package tripvisUI.infoboxes
{
	import flash.events.MouseEvent;
	
	import mx.containers.HBox;
	import mx.controls.Button;
	
	import tripvisModel.SimpleTripItem;
	
	import tripvisUI.events.InfoboxEvent;
	import tripvisUI.languages.LanguageDirector;
	
	[Event(name="addToTripBasket", type="tripvisUI.events.InfoboxEvent")]
	public class MapInfobox extends AbstractInfobox
	{
		public function MapInfobox(simpleTripItem: SimpleTripItem)
		{
			super();
			
			this._simpleTripItem = simpleTripItem;
			

		}
		
		override protected function createChildren():void
		{
			super.createChildren();
		
			//scrolltext inkorten
			this.scrolltext.height -= 28;
			
			// we willen hbox met daarin een button die een addToTripBasket-event dispatched
			// button:
			var addToTripBasketButton: Button = new Button();
			addToTripBasketButton.label = LanguageDirector.instance.language.addToTripBasket;
			addToTripBasketButton.addEventListener(MouseEvent.CLICK, buttonAddToTripBasket_click); // click handler toevoegen aan button
			
			// box:
			var box: HBox = new HBox();
			box.percentWidth = 100;
			box.setStyle('horizontalAlign', 'center'); //button in't midden zetten

			box.addChild(addToTripBasketButton);
			this.addChild(box);
		}
		
		private function buttonAddToTripBasket_click(event: MouseEvent): void
		{
			var eventObj: InfoboxEvent = new InfoboxEvent("addToTripBasket");
			eventObj.tripItem = this._simpleTripItem;
			dispatchEvent(eventObj);
		}
		
	}
}