package tripvisUI.infoboxes
{
	import flash.events.MouseEvent;
	
	import mx.containers.HBox;
	import mx.controls.Button;
	
	import tripvisModel.TripItem;
	
	import tripvisUI.events.InfoboxEvent;
	import tripvisUI.languages.LanguageDirector;
	
	[Event(name="addToTimeline", type="tripvisUI.events.InfoboxEvent")]
	public class VisualisingBasketInfobox extends AbstractVisualisingInfobox
	{
		public function VisualisingBasketInfobox(tripItem: TripItem)
		{
			super(tripItem);
		}
		
		override protected function createChildren():void
		{
			super.createChildren();
			
			//scrolltext verlengen
			this.scrolltext.height += 4;
			
			// we willen een knop om dit item toe toevoegen aan de tijdslijn
			
			// button:
			var addToTimelineButton: Button = new Button();
			addToTimelineButton.label = LanguageDirector.instance.language.addToTimeline;
			addToTimelineButton.addEventListener(MouseEvent.CLICK, buttonAddToTimeline_click); // click handler toevoegen aan button
			
			// box:
			var box: HBox = new HBox();
			box.percentWidth = 100;
			box.setStyle('horizontalAlign', 'center'); //button in't midden zetten
			

			box.addChild(addToTimelineButton);
			this.addChild(box);
		}
		
		private function buttonAddToTimeline_click(event: MouseEvent): void
		{
			var eventObj: InfoboxEvent = new InfoboxEvent("addToTimeline");
			eventObj.tripItem = this._simpleTripItem;
			dispatchEvent(eventObj);
		}
		
	}
}