package tripvisUI.languages
{

	public class LanguageDirector
	{
		/* Singleton */
		private static var _languageDirectorModel: LanguageDirector = new LanguageDirector();
		
		public static function get instance(): LanguageDirector
		{
			return _languageDirectorModel;
		}
	
		
		private var _languageBuilder: AbstractLanguageBuilder;
		
		public function setLanguageBuilder(languageBuilder: AbstractLanguageBuilder): void
		{
			_languageBuilder = languageBuilder;
			constructLanguage();
		}
		
		[Bindable]
		public function get language(): Language
		{
			return _languageBuilder.getLanguage();
		}
		
		private function constructLanguage(): void
		{
			_languageBuilder.constructNewLanguage();
			_languageBuilder.buildLanguageTerms();
		}
		


	}
}